package com.example.demo.order_lines.model;

import java.util.Objects;

import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import com.example.demo.core.model.BaseEntity;
import com.example.demo.orders.model.OrderEntity;
import com.example.demo.products.model.ProductEntity;
import com.fasterxml.jackson.annotation.JsonBackReference;

public class OrderLineEntity extends BaseEntity {

    private Integer count;
    private ProductEntity product;
    private Double totalPrice;
    @ManyToOne
    @JoinColumn(name = "order_id")
    @JsonBackReference // Это свойство не управляется родительским объектом
    private OrderEntity order;

    public OrderLineEntity() {

    }

    public OrderLineEntity(Long id, ProductEntity product, Integer count, Double totalPrice) {
        super(id);
        this.product = product;
        this.count = count;
        this.totalPrice = totalPrice;
    }

    public ProductEntity getProduct() {
        return product;
    }

    public void setProduct(ProductEntity product) {
        this.product = product;
    }

    public Integer getCount() {
        return count;
    }

    public void setCount(Integer count) {
        this.count = count;
    }

    public Double getTotalPrice() {
        return totalPrice;
    }

    public void setTotalPrice(Double totalPrice) {
        this.totalPrice = totalPrice;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, product, count);
    }

    @SuppressWarnings("unlikely-arg-order-product")
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final OrderLineEntity other = (OrderLineEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getProduct(), product)
                && Objects.equals(other.getCount(), count);
    }
}
