package com.example.demo.order_lines.service;

import java.util.List;
import java.util.Objects;
import java.util.Optional;

import org.springframework.stereotype.Service;

import com.example.demo.core.error.NotFoundException;
import com.example.demo.order_lines.model.OrderLineEntity;
import com.example.demo.order_lines.repository.OrderLineRepository;

@Service
public class OrderLineService {
    private final OrderLineRepository repository;

    public OrderLineService(OrderLineRepository repository) {
        this.repository = repository;
    }

    public List<OrderLineEntity> getAll(Long orderLineId) {
        if (Objects.equals(orderLineId, 0L)) {
            return repository.getAll();
        }
        return repository.getAll();
    }

    public OrderLineEntity get(Long id) {
        return Optional.ofNullable(repository.get(id))
                .orElseThrow(() -> new NotFoundException(id));
    }

    public OrderLineEntity create(OrderLineEntity entity) {
        return repository.create(entity);
    }

    public OrderLineEntity update(Long id, OrderLineEntity entity) {
        final OrderLineEntity existsEntity = get(id);
        existsEntity.setProduct(entity.getProduct());
        existsEntity.setCount(entity.getCount());
        return repository.update(existsEntity);
    }

    public OrderLineEntity delete(Long id) {
        final OrderLineEntity existsEntity = get(id);
        return repository.delete(existsEntity);
    }
}
