package com.example.demo.orders.api;

import java.sql.Date;
import java.util.ArrayList;
import java.util.List;

import com.example.demo.order_lines.api.OrderLineDto;
import com.fasterxml.jackson.annotation.JsonProperty;

import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.NotNull;

public class OrderDto {
    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private Long id;
    @NotNull
    @Min(1)
    private Long userId;
    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private Date date = getDate();
    @NotNull
    private final List<OrderLineDto> lines = new ArrayList<>();

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public List<OrderLineDto> getLines() {
        return lines;
    }

    // метод для добавленя строк заказа
    public void addOrderLine(OrderLineDto orderLine) {
        this.lines.add(orderLine);
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public Date getDate() {
        return date;
    }
}
