package com.example.demo.orders.model;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

import com.example.demo.core.model.BaseEntity;
import com.example.demo.order_lines.model.OrderLineEntity;
import com.example.demo.users.model.UserEntity;
import com.fasterxml.jackson.annotation.JsonManagedReference;

public class OrderEntity extends BaseEntity {
    private UserEntity user;
    @JsonManagedReference
    private final List<OrderLineEntity> lines = new ArrayList<>();

    public OrderEntity() {
        super();
    }

    public OrderEntity(Long id, UserEntity user, List<OrderLineEntity> lines) {
        super(id);
        this.user = user;
        this.lines.clear();
        this.lines.addAll(lines);
    }

    public UserEntity getUser() {
        return user;
    }

    public void setUser(UserEntity user) {
        this.user = user;
    }

    public List<OrderLineEntity> getLines() {
        return lines;
    }

    public void setLines(OrderLineEntity line) {
        this.lines.add(line);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, user, lines);
    }

    @SuppressWarnings("unlikely-arg-user")
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final OrderEntity other = (OrderEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getUser(), user)
                && Objects.equals(other.getLines(), lines);
    }

    // метод добавления строк заказа в заказ
    public void addOrderLine(OrderLineEntity orderLine) {
        this.lines.add(orderLine);
    }
}
