package com.example.demo.users.model;

import java.util.Objects;

import com.example.demo.core.model.BaseEntity;

public class UserEntity extends BaseEntity {
    private String fullname;
    private String surname;
    private String email;
    private String password;

    public UserEntity() {
        super();
    }

    public UserEntity(Long id, String fullname, String surname, String email, String password) {
        super(id);
        this.fullname = fullname;
        this.surname = surname;
        this.email = email;
        this.password = password;
    }

    public String getFullname() {
        return fullname;
    }

    public void setFullname(String fullname) {
        this.fullname = fullname;
    }

    public String getSurname() {
        return surname;
    }

    public void setSurname(String surname) {
        this.surname = surname;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, fullname, surname, email, password);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final UserEntity other = (UserEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getFullname(), fullname)
                && Objects.equals(other.getSurname(), surname)
                && Objects.equals(other.getEmail(), email)
                && Objects.equals(other.getPassword(), password);
    }
}
